library("rgp")

myDivide <- function(a,b){if (b==0) return(a) else return (a/b)}

setNeterminale <- functionSet("+", "*", "-","myDivide","sin","cos")

setVariabile <- inputVariableSet("x")

setConstante <- constantFactorySet(function() rnorm(1))

eps <- 0.1

dateX <- seq(from = -pi/2+eps, to = pi/2-eps, by = 0.1)

functieScor <- function(f) rmse(f(dateX), tan(dateX))


set.seed(1)
gpRezultat <- 
geneticProgramming(functionSet = setNeterminale,inputVariables = setVariabile,constantSet = setConstante,
                   fitnessFunction = functieScor,stopCondition = makeStepsStopCondition(1000))

bestSolution1 <- gpRezultat$population[[which.min(gpRezultat$fitnessValues)]]

plot(y = bestSolution1(dateX), x = dateX, type = "l",lty = 1, xlab = "x", ylab = "y")

lines(y = tan(dateX), x = dateX, lty = 2, col="red")